package oracle;

import java.sql.*;
import oracle.jdbc.pool.OracleDataSource;

/**
 *
 * @author Miroslav Balk
 */
public class Main {

    public static void test1() throws Exception {
        // pi pekladu nen nutno mt ovlada v classpath
        Class.forName("oracle.jdbc.driver.OracleDriver");

        // oteven spojen s databz
        // - jdbc oznauje JDBC "URI", oracle oznauje pouit JDBC protokol
        //   (prakticky ovlada) a thin je sub-protokol (prakticky typ spojen)
        // oraserv... host
        //devaite SID
        Connection conn = DriverManager.getConnection(
                "jdbc:oracle:thin:@oraserv.felk.cvut.cz:1521:devaite", "T10", "oracle");

        // poloen SQL dotazu
        Statement st = conn.createStatement();
        ResultSet rs = st.executeQuery("SELECT banner FROM SYS.V_$VERSION");

        // vypsn vsledku
        while (rs.next()) {
            // prvn sloupec vsledku jako java.lang.String
            System.out.println(rs.getString(1));
        }

        // uzaven dotazu i vech vsledk
        st.close();

        // uzaven spojen
        conn.close();
    }

    public static void test2() throws Exception {
        Class.forName("oracle.jdbc.driver.OracleDriver");
        Connection conn = DriverManager.getConnection(
                "jdbc:oracle:thin:@oraserv.felk.cvut.cz:1521:devaite", "T10", "oracle");
        Statement st = conn.createStatement();
        ResultSet rs = st.executeQuery(
                // "select L_id from pacient join navsteva using (p_id) where p_jmeno = ?"
                "select P_jmeno, P_adresa from pacient  where P_adresa >= 'Picadili' order by P_nar" //"select * from pacient"
                );
        // vypsn vsledku
        System.out.println("Tabulka pacient ");
        System.out.printf("%10s %20s\n", "  Jmno", "     Adresa");
        while (rs.next()) {
            System.out.printf("%10s %20s\n", rs.getString("P_JMENO"), rs.getString("P_adresa"));
        }
        st.close();
        conn.close();
    }

    public static String getAdresa(String jmenoPacienta) throws Exception {
        Class.forName("oracle.jdbc.driver.OracleDriver");
        Connection conn = DriverManager.getConnection(
                "jdbc:oracle:thin:@oraserv.felk.cvut.cz:1521:devaite", "T10", "oracle");
        Statement st = conn.createStatement();
        ResultSet rs = st.executeQuery(
                "select * from pacient  where P_jmeno= '" + jmenoPacienta + "' ");
        rs.next();
        String vysledek = rs.getString("P_adresa");
        st.close();
        conn.close();
        return vysledek;
    }

    public static String getAdresaPS(String jmenoPacienta) throws Exception {
        Class.forName("oracle.jdbc.driver.OracleDriver");
        Connection conn = DriverManager.getConnection(
                "jdbc:oracle:thin:@oraserv.felk.cvut.cz:1521:devaite", "T10", "oracle");
        // poloen SQL dotazu, v podmnce se pouv placeholder
        PreparedStatement pst = conn.prepareStatement(
                "select * from pacient  where P_jmeno=?");
        pst.setString(1, jmenoPacienta);

        ResultSet rs = pst.executeQuery();
        rs.next();
        String vysledek = rs.getString("P_adresa");
        pst.close();
        conn.close();
        return vysledek;
    }

    public static void test3() throws Exception {
        OracleDataSource ds = new OracleDataSource();//modernejsi zpusob pomocoi datasource
        //jdbc:oracle:thin:@oraserv.felk.cvut.cz:1521:devaite
        // @machineName:port:SID,   userid,  password
        ds.setDriverType("thin");
        ds.setServerName("oraserv.felk.cvut.cz");
        ds.setPortNumber(1521);
        ds.setDatabaseName("devaite"); // sid
        ds.setUser("S1");
        ds.setPassword("oracle");

        Connection conn = ds.getConnection();

        Statement stmt = conn.createStatement();
        ResultSet rs = stmt.executeQuery("SELECT banner FROM SYS.V_$VERSION");

        // vypsn vsledku
        while (rs.next()) {
            // prvn sloupec vsledku jako java.lang.String
            System.out.println(rs.getString(1));
        }

        // uzaven dotazu i vech vsledk
        stmt.close();

        // uzaven spojen
        conn.close();

    }

    public static void main(String args[]) {

        try {
            test2();
            System.out.println("Adresa pan Hust je " + getAdresaPS("Hust"));
        } catch (Exception ex) {
            ex.printStackTrace();
        }

    }
}
